Hex Artifact Content

Artifact 28a52cfdd8c72163aca9c5f967ec2c1991b69fbd:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 53 65 74 20 74 69 6d 65  bash..# Set time
0020: 7a 6f 6e 65 20 74 6f 20 64 65 66 61 75 6c 74 0a  zone to default.
0030: 54 5a 3d 55 54 43 0a 65 78 70 6f 72 74 20 54 5a  TZ=UTC.export TZ
0040: 0a 0a 74 61 72 67 65 74 6d 6f 64 65 3d 27 69 6e  ..targetmode='in
0050: 73 74 61 6c 6c 27 0a 69 66 20 5b 20 22 24 31 22  stall'.if [ "$1"
0060: 20 3d 3d 20 27 2d 2d 63 70 69 6f 27 20 5d 3b 20   == '--cpio' ]; 
0070: 74 68 65 6e 0a 09 74 61 72 67 65 74 6d 6f 64 65  then..targetmode
0080: 3d 27 61 72 63 68 69 76 65 27 0a 0a 09 73 68 69  ='archive'...shi
0090: 66 74 0a 66 69 0a 0a 70 6b 67 3d 22 24 28 65 63  ft.fi..pkg="$(ec
00a0: 68 6f 20 22 24 31 22 20 7c 20 73 65 64 20 27 73  ho "$1" | sed 's
00b0: 40 2f 2a 24 40 40 3b 73 40 5e 5c 2e 2a 2f 2a 40  @/*$@@;s@^\.*/*@
00c0: 40 27 29 22 0a 0a 69 66 20 5b 20 2d 7a 20 22 24  @')"..if [ -z "$
00d0: 7b 70 6b 67 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  {pkg}" ]; then..
00e0: 65 63 68 6f 20 22 55 73 61 67 65 3a 20 62 75 69  echo "Usage: bui
00f0: 6c 64 20 5b 2d 2d 63 70 69 6f 5d 20 3c 70 61 63  ld [--cpio] <pac
0100: 6b 61 67 65 3e 22 20 32 3e 26 31 0a 0a 09 65 78  kage>" 2>&1...ex
0110: 69 74 20 31 0a 66 69 0a 0a 66 75 6e 63 74 69 6f  it 1.fi..functio
0120: 6e 20 64 6f 77 6e 6c 6f 61 64 28 29 20 7b 0a 09  n download() {..
0130: 69 66 20 5b 20 21 20 2d 65 20 22 24 7b 70 6b 67  if [ ! -e "${pkg
0140: 61 72 63 68 69 76 65 7d 22 20 5d 3b 20 74 68 65  archive}" ]; the
0150: 6e 0a 09 09 23 20 44 6f 77 6e 6c 6f 61 64 0a 09  n...# Download..
0160: 09 23 23 20 43 6c 65 61 6e 75 70 0a 09 09 72 6d  .## Cleanup...rm
0170: 20 2d 66 20 73 72 63 2e 6e 65 77 0a 0a 09 09 23   -f src.new....#
0180: 23 20 46 65 74 63 68 20 66 69 6c 65 0a 09 09 77  # Fetch file...w
0190: 67 65 74 20 2d 4f 20 73 72 63 2e 6e 65 77 20 22  get -O src.new "
01a0: 24 7b 75 72 6c 7d 22 20 7c 7c 20 65 78 69 74 20  ${url}" || exit 
01b0: 31 0a 0a 09 09 23 23 20 56 65 72 69 66 79 20 73  1....## Verify s
01c0: 69 67 6e 61 74 75 72 65 0a 09 09 73 72 63 5f 73  ignature...src_s
01d0: 68 61 32 35 36 3d 22 24 28 6f 70 65 6e 73 73 6c  ha256="$(openssl
01e0: 20 73 68 61 32 35 36 20 27 73 72 63 2e 6e 65 77   sha256 'src.new
01f0: 27 20 7c 20 73 65 64 20 27 73 40 5e 2e 2a 3d 20  ' | sed 's@^.*= 
0200: 40 40 27 29 22 0a 09 09 69 66 20 5b 20 22 24 7b  @@')"...if [ "${
0210: 73 72 63 5f 73 68 61 32 35 36 7d 22 20 21 3d 20  src_sha256}" != 
0220: 22 24 7b 73 68 61 32 35 36 7d 22 20 5d 3b 20 74  "${sha256}" ]; t
0230: 68 65 6e 0a 09 09 09 65 63 68 6f 20 22 53 48 41  hen....echo "SHA
0240: 32 35 36 20 6d 69 73 6d 61 74 63 68 3a 20 20 44  256 mismatch:  D
0250: 6f 77 6e 6c 6f 61 64 65 64 3a 20 24 7b 73 72 63  ownloaded: ${src
0260: 5f 73 68 61 32 35 36 7d 20 21 3d 20 45 78 70 65  _sha256} != Expe
0270: 63 74 65 64 3a 20 24 7b 73 68 61 32 35 36 7d 22  cted: ${sha256}"
0280: 20 3e 26 32 0a 0a 09 09 09 65 78 69 74 20 31 0a   >&2.....exit 1.
0290: 09 09 66 69 0a 0a 09 09 23 23 20 4d 6f 76 65 20  ..fi....## Move 
02a0: 66 69 6c 65 20 69 6e 74 6f 20 70 6c 61 63 65 0a  file into place.
02b0: 09 09 6d 76 20 73 72 63 2e 6e 65 77 20 22 24 7b  ..mv src.new "${
02c0: 70 6b 67 61 72 63 68 69 76 65 7d 22 0a 09 66 69  pkgarchive}"..fi
02d0: 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 65 78 74  .}..function ext
02e0: 72 61 63 74 28 29 20 7b 0a 09 6c 6f 63 61 6c 20  ract() {..local 
02f0: 64 65 63 6f 6d 70 72 65 73 73 0a 0a 09 23 20 44  decompress...# D
0300: 65 63 6f 6d 70 72 65 73 73 20 61 72 63 68 69 76  ecompress archiv
0310: 65 0a 09 23 23 20 44 65 74 65 72 6d 69 6e 65 20  e..## Determine 
0320: 74 79 70 65 20 6f 66 20 61 72 63 68 69 76 65 0a  type of archive.
0330: 09 63 61 73 65 20 22 24 7b 75 72 6c 7d 22 20 69  .case "${url}" i
0340: 6e 0a 09 09 2a 2e 74 61 72 2e 78 7a 7c 2a 2e 74  n...*.tar.xz|*.t
0350: 61 72 2e 78 7a 27 3f 27 2a 7c 2a 2e 74 78 7a 29  ar.xz'?'*|*.txz)
0360: 0a 09 09 09 64 65 63 6f 6d 70 72 65 73 73 3d 27  ....decompress='
0370: 78 7a 27 0a 09 09 09 3b 3b 0a 09 09 2a 2e 74 61  xz'....;;...*.ta
0380: 72 2e 67 7a 7c 2a 2e 74 61 72 2e 67 7a 27 3f 27  r.gz|*.tar.gz'?'
0390: 2a 7c 2a 2e 74 67 7a 29 0a 09 09 09 64 65 63 6f  *|*.tgz)....deco
03a0: 6d 70 72 65 73 73 3d 27 67 7a 69 70 27 0a 09 09  mpress='gzip'...
03b0: 09 3b 3b 0a 09 09 2a 2e 74 61 72 2e 62 7a 32 7c  .;;...*.tar.bz2|
03c0: 2a 2e 74 61 72 2e 62 7a 32 27 3f 27 2a 7c 2a 2e  *.tar.bz2'?'*|*.
03d0: 74 62 7a 32 29 0a 09 09 09 64 65 63 6f 6d 70 72  tbz2)....decompr
03e0: 65 73 73 3d 27 62 7a 69 70 32 27 0a 09 09 09 3b  ess='bzip2'....;
03f0: 3b 0a 09 09 2a 2e 7a 69 70 7c 2a 2e 7a 69 70 27  ;...*.zip|*.zip'
0400: 3f 27 2a 29 0a 09 09 09 64 65 63 6f 6d 70 72 65  ?'*)....decompre
0410: 73 73 3d 27 75 6e 7a 69 70 27 0a 09 09 09 3b 3b  ss='unzip'....;;
0420: 0a 09 09 2a 29 0a 09 09 09 65 63 68 6f 20 22 55  ...*)....echo "U
0430: 6e 6b 6e 6f 77 6e 20 63 6f 6d 70 72 65 73 73 69  nknown compressi
0440: 6f 6e 20 6d 65 74 68 6f 64 3a 20 24 7b 75 72 6c  on method: ${url
0450: 7d 22 20 3e 26 32 0a 0a 09 09 09 65 78 69 74 20  }" >&2.....exit 
0460: 31 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 0a 09  1....;;..esac...
0470: 23 23 20 44 6f 20 64 65 63 6f 6d 70 72 65 73 73  ## Do decompress
0480: 69 6f 6e 0a 09 63 61 73 65 20 22 24 7b 64 65 63  ion..case "${dec
0490: 6f 6d 70 72 65 73 73 7d 22 20 69 6e 0a 09 09 75  ompress}" in...u
04a0: 6e 7a 69 70 29 0a 09 09 09 75 6e 7a 69 70 20 22  nzip)....unzip "
04b0: 24 7b 70 6b 67 61 72 63 68 69 76 65 7d 22 20 7c  ${pkgarchive}" |
04c0: 7c 20 64 69 65 20 27 55 6e 61 62 6c 65 20 74 6f  | die 'Unable to
04d0: 20 75 6e 63 6f 6d 70 72 65 73 73 20 61 72 63 68   uncompress arch
04e0: 69 76 65 27 0a 09 09 09 3b 3b 0a 09 09 2a 29 0a  ive'....;;...*).
04f0: 09 09 09 22 24 7b 64 65 63 6f 6d 70 72 65 73 73  ..."${decompress
0500: 7d 22 20 2d 64 63 20 22 24 7b 70 6b 67 61 72 63  }" -dc "${pkgarc
0510: 68 69 76 65 7d 22 20 7c 20 74 61 72 20 2d 78 66  hive}" | tar -xf
0520: 20 2d 20 7c 7c 20 64 69 65 20 27 55 6e 61 62 6c   - || die 'Unabl
0530: 65 20 74 6f 20 75 6e 63 6f 6d 70 72 65 73 73 20  e to uncompress 
0540: 61 72 63 68 69 76 65 27 0a 09 09 09 3b 3b 0a 09  archive'....;;..
0550: 65 73 61 63 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  esac.}..function
0560: 20 61 70 70 6c 79 5f 70 61 74 63 68 65 73 28 29   apply_patches()
0570: 20 7b 0a 09 6c 6f 63 61 6c 20 70 61 74 63 68 0a   {..local patch.
0580: 0a 09 66 6f 72 20 70 61 74 63 68 20 69 6e 20 22  ..for patch in "
0590: 24 7b 70 6b 67 64 69 72 7d 2f 70 61 74 63 68 65  ${pkgdir}/patche
05a0: 73 22 2f 2a 3b 20 64 6f 0a 09 09 69 66 20 5b 20  s"/*; do...if [ 
05b0: 21 20 2d 65 20 22 24 7b 70 61 74 63 68 7d 22 20  ! -e "${patch}" 
05c0: 5d 3b 20 74 68 65 6e 0a 09 09 09 63 6f 6e 74 69  ]; then....conti
05d0: 6e 75 65 0a 09 09 66 69 0a 0a 09 09 63 61 73 65  nue...fi....case
05e0: 20 22 24 7b 70 61 74 63 68 7d 22 20 69 6e 0a 09   "${patch}" in..
05f0: 09 09 2a 2e 64 69 66 66 7c 2a 2e 70 61 74 63 68  ..*.diff|*.patch
0600: 29 0a 09 09 09 09 3b 3b 0a 09 09 09 2a 29 0a 09  ).....;;....*)..
0610: 09 09 09 63 6f 6e 74 69 6e 75 65 0a 09 09 09 09  ...continue.....
0620: 3b 3b 0a 09 09 65 73 61 63 0a 0a 09 09 69 66 20  ;;...esac....if 
0630: 5b 20 2d 65 20 22 24 7b 70 61 74 63 68 7d 2e 73  [ -e "${patch}.s
0640: 68 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 69 66  h" ]; then....if
0650: 20 21 20 73 68 20 22 24 7b 70 61 74 63 68 7d 2e   ! sh "${patch}.
0660: 73 68 22 3b 20 74 68 65 6e 0a 09 09 09 09 63 6f  sh"; then.....co
0670: 6e 74 69 6e 75 65 0a 09 09 09 66 69 0a 09 09 66  ntinue....fi...f
0680: 69 0a 0a 09 09 70 61 74 63 68 20 2d 70 31 20 3c  i....patch -p1 <
0690: 20 22 24 7b 70 61 74 63 68 7d 22 0a 09 64 6f 6e   "${patch}"..don
06a0: 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 76 65  e.}..function ve
06b0: 72 69 66 79 52 65 71 75 69 72 65 64 50 61 63 6b  rifyRequiredPack
06c0: 61 67 65 73 28 29 20 7b 0a 09 6c 6f 63 61 6c 20  ages() {..local 
06d0: 70 6b 67 20 70 6b 67 64 6f 6d 61 69 6e 20 70 6b  pkg pkgdomain pk
06e0: 67 76 65 72 73 69 6f 6e 0a 09 6c 6f 63 61 6c 20  gversion..local 
06f0: 70 6b 67 64 69 72 20 70 6b 67 63 6f 6e 66 69 67  pkgdir pkgconfig
0700: 64 69 72 20 70 6b 67 66 6f 75 6e 64 0a 0a 09 66  dir pkgfound...f
0710: 6f 72 20 70 6b 67 20 69 6e 20 22 24 7b 72 65 71  or pkg in "${req
0720: 75 69 72 65 5b 40 5d 7d 22 3b 20 64 6f 0a 09 09  uire[@]}"; do...
0730: 70 6b 67 64 6f 6d 61 69 6e 3d 27 27 0a 09 09 70  pkgdomain=''...p
0740: 6b 67 76 65 72 73 69 6f 6e 3d 27 27 0a 09 09 70  kgversion=''...p
0750: 6b 67 63 68 61 6e 67 65 73 3d 28 43 46 4c 41 47  kgchanges=(CFLAG
0760: 53 20 4c 44 46 4c 41 47 53 20 50 41 54 48 20 50  S LDFLAGS PATH P
0770: 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54 48 29 0a  KG_CONFIG_PATH).
0780: 0a 09 09 63 61 73 65 20 22 24 7b 70 6b 67 7d 22  ...case "${pkg}"
0790: 20 69 6e 0a 09 09 09 2a 3a 2a 29 0a 09 09 09 09   in....*:*).....
07a0: 70 6b 67 63 68 61 6e 67 65 73 3d 28 24 28 65 63  pkgchanges=($(ec
07b0: 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75  ho "${pkg}" | cu
07c0: 74 20 2d 66 20 32 20 2d 64 20 27 3a 27 29 29 0a  t -f 2 -d ':')).
07d0: 09 09 09 09 70 6b 67 3d 22 24 28 65 63 68 6f 20  ....pkg="$(echo 
07e0: 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74 20 2d  "${pkg}" | cut -
07f0: 66 20 31 20 2d 64 20 27 3a 27 29 22 0a 09 09 09  f 1 -d ':')"....
0800: 09 3b 3b 0a 09 09 65 73 61 63 0a 0a 09 09 63 61  .;;...esac....ca
0810: 73 65 20 22 24 7b 70 6b 67 7d 22 20 69 6e 0a 09  se "${pkg}" in..
0820: 09 09 40 2a 29 0a 09 09 09 09 23 20 46 61 6b 65  ..@*).....# Fake
0830: 20 70 61 63 6b 61 67 65 0a 09 09 09 09 63 6f 6e   package.....con
0840: 74 69 6e 75 65 0a 09 09 09 09 3b 3b 0a 09 09 09  tinue.....;;....
0850: 2a 2f 2a 40 2a 29 0a 09 09 09 09 70 6b 67 64 6f  */*@*).....pkgdo
0860: 6d 61 69 6e 3d 22 24 28 65 63 68 6f 20 22 24 7b  main="$(echo "${
0870: 70 6b 67 7d 22 20 7c 20 63 75 74 20 2d 66 20 32  pkg}" | cut -f 2
0880: 20 2d 64 20 27 40 27 29 22 0a 09 09 09 09 70 6b   -d '@')".....pk
0890: 67 76 65 72 73 69 6f 6e 3d 22 24 28 65 63 68 6f  gversion="$(echo
08a0: 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74 20   "${pkg}" | cut 
08b0: 2d 66 20 32 20 2d 64 20 27 2f 27 20 7c 20 63 75  -f 2 -d '/' | cu
08c0: 74 20 2d 66 20 31 20 2d 64 20 27 40 27 29 22 0a  t -f 1 -d '@')".
08d0: 09 09 09 09 70 6b 67 3d 22 24 28 65 63 68 6f 20  ....pkg="$(echo 
08e0: 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74 20 2d  "${pkg}" | cut -
08f0: 66 20 31 20 2d 64 20 27 2f 27 29 22 0a 09 09 09  f 1 -d '/')"....
0900: 09 3b 3b 0a 09 09 09 2a 2f 2a 29 0a 09 09 09 09  .;;....*/*).....
0910: 70 6b 67 76 65 72 73 69 6f 6e 3d 22 24 28 65 63  pkgversion="$(ec
0920: 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75  ho "${pkg}" | cu
0930: 74 20 2d 66 20 32 20 2d 64 20 27 2f 27 29 22 0a  t -f 2 -d '/')".
0940: 09 09 09 09 70 6b 67 3d 22 24 28 65 63 68 6f 20  ....pkg="$(echo 
0950: 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74 20 2d  "${pkg}" | cut -
0960: 66 20 31 20 2d 64 20 27 2f 27 29 22 0a 09 09 09  f 1 -d '/')"....
0970: 09 3b 3b 0a 09 09 09 2a 40 2a 29 0a 09 09 09 09  .;;....*@*).....
0980: 70 6b 67 64 6f 6d 61 69 6e 3d 22 24 28 65 63 68  pkgdomain="$(ech
0990: 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74  o "${pkg}" | cut
09a0: 20 2d 66 20 32 20 2d 64 20 27 40 27 29 22 0a 09   -f 2 -d '@')"..
09b0: 09 09 09 70 6b 67 3d 22 24 28 65 63 68 6f 20 22  ...pkg="$(echo "
09c0: 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74 20 2d 66  ${pkg}" | cut -f
09d0: 20 31 20 2d 64 20 27 40 27 29 22 0a 09 09 09 09   1 -d '@')".....
09e0: 3b 3b 0a 09 09 65 73 61 63 0a 0a 09 09 69 66 20  ;;...esac....if 
09f0: 5b 20 2d 7a 20 22 24 7b 70 6b 67 64 6f 6d 61 69  [ -z "${pkgdomai
0a00: 6e 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 70  n}" ]; then....p
0a10: 6b 67 64 6f 6d 61 69 6e 3d 22 24 7b 64 6f 6d 61  kgdomain="${doma
0a20: 69 6e 7d 22 0a 09 09 66 69 0a 0a 09 09 70 6b 67  in}"...fi....pkg
0a30: 66 6f 75 6e 64 3d 27 30 27 0a 09 09 66 6f 72 20  found='0'...for 
0a40: 70 6b 67 64 69 72 20 69 6e 20 22 2f 6f 70 74 2f  pkgdir in "/opt/
0a50: 61 70 70 66 73 2f 24 7b 70 6b 67 64 6f 6d 61 69  appfs/${pkgdomai
0a60: 6e 7d 2f 24 7b 70 6b 67 7d 2f 70 6c 61 74 66 6f  n}/${pkg}/platfo
0a70: 72 6d 22 2f 24 7b 70 6b 67 76 65 72 73 69 6f 6e  rm"/${pkgversion
0a80: 3a 2d 6c 61 74 65 73 74 7d 20 22 2f 6f 70 74 2f  :-latest} "/opt/
0a90: 61 70 70 66 73 2f 24 7b 70 6b 67 64 6f 6d 61 69  appfs/${pkgdomai
0aa0: 6e 7d 2f 24 7b 70 6b 67 7d 2f 70 6c 61 74 66 6f  n}/${pkg}/platfo
0ab0: 72 6d 22 2f 24 7b 70 6b 67 76 65 72 73 69 6f 6e  rm"/${pkgversion
0ac0: 3a 2d 2a 7d 3b 20 64 6f 0a 09 09 09 70 6b 67 63  :-*}; do....pkgc
0ad0: 6f 6e 66 69 67 64 69 72 3d 22 24 7b 70 6b 67 64  onfigdir="${pkgd
0ae0: 69 72 7d 2f 6c 69 62 2f 70 6b 67 63 6f 6e 66 69  ir}/lib/pkgconfi
0af0: 67 22 0a 0a 09 09 09 69 66 20 5b 20 21 20 2d 64  g".....if [ ! -d
0b00: 20 22 24 7b 70 6b 67 64 69 72 7d 22 20 5d 3b 20   "${pkgdir}" ]; 
0b10: 74 68 65 6e 0a 09 09 09 09 63 6f 6e 74 69 6e 75  then.....continu
0b20: 65 0a 09 09 09 66 69 0a 0a 09 09 09 23 20 49 66  e....fi.....# If
0b30: 20 74 68 65 20 70 61 63 6b 61 67 65 20 76 65 72   the package ver
0b40: 73 69 6f 6e 20 77 61 73 20 75 6e 73 70 65 63 69  sion was unspeci
0b50: 66 69 65 64 2c 20 66 75 6c 6c 79 20 72 65 73 6f  fied, fully reso
0b60: 6c 76 65 0a 09 09 09 23 20 74 68 65 20 64 69 72  lve....# the dir
0b70: 65 63 74 6f 72 79 20 74 68 61 74 20 77 65 20 66  ectory that we f
0b80: 6f 75 6e 64 0a 09 09 09 69 66 20 5b 20 2d 7a 20  ound....if [ -z 
0b90: 22 24 7b 70 6b 67 76 65 72 73 69 6f 6e 7d 22 20  "${pkgversion}" 
0ba0: 5d 3b 20 74 68 65 6e 0a 09 09 09 09 70 6b 67 64  ]; then.....pkgd
0bb0: 69 72 3d 22 24 28 72 65 61 64 6c 69 6e 6b 20 2d  ir="$(readlink -
0bc0: 66 20 22 24 7b 70 6b 67 64 69 72 7d 22 29 22 0a  f "${pkgdir}")".
0bd0: 09 09 09 66 69 0a 0a 09 09 09 70 6b 67 66 6f 75  ...fi.....pkgfou
0be0: 6e 64 3d 27 31 27 0a 0a 09 09 09 66 6f 72 20 70  nd='1'.....for p
0bf0: 6b 67 63 68 61 6e 67 65 20 69 6e 20 22 24 7b 70  kgchange in "${p
0c00: 6b 67 63 68 61 6e 67 65 73 5b 40 5d 7d 22 3b 20  kgchanges[@]}"; 
0c10: 64 6f 0a 09 09 09 09 63 61 73 65 20 22 24 7b 70  do.....case "${p
0c20: 6b 67 63 68 61 6e 67 65 7d 22 20 69 6e 0a 09 09  kgchange}" in...
0c30: 09 09 09 43 46 4c 41 47 53 29 0a 09 09 09 09 09  ...CFLAGS)......
0c40: 09 43 46 4c 41 47 53 3d 22 24 7b 43 46 4c 41 47  .CFLAGS="${CFLAG
0c50: 53 7d 20 2d 69 73 79 73 74 65 6d 20 24 7b 70 6b  S} -isystem ${pk
0c60: 67 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22 0a 09  gdir}/include"..
0c70: 09 09 09 09 09 43 50 50 46 4c 41 47 53 3d 22 24  .....CPPFLAGS="$
0c80: 7b 43 50 50 46 4c 41 47 53 7d 20 2d 69 73 79 73  {CPPFLAGS} -isys
0c90: 74 65 6d 20 24 7b 70 6b 67 64 69 72 7d 2f 69 6e  tem ${pkgdir}/in
0ca0: 63 6c 75 64 65 22 0a 09 09 09 09 09 09 65 78 70  clude".......exp
0cb0: 6f 72 74 20 43 46 4c 41 47 53 20 43 50 50 46 4c  ort CFLAGS CPPFL
0cc0: 41 47 53 0a 09 09 09 09 09 09 3b 3b 0a 09 09 09  AGS.......;;....
0cd0: 09 09 4c 44 46 4c 41 47 53 29 0a 09 09 09 09 09  ..LDFLAGS)......
0ce0: 09 4c 44 46 4c 41 47 53 3d 22 24 7b 4c 44 46 4c  .LDFLAGS="${LDFL
0cf0: 41 47 53 7d 20 2d 4c 24 7b 70 6b 67 64 69 72 7d  AGS} -L${pkgdir}
0d00: 2f 6c 69 62 20 2d 57 6c 2c 2d 72 70 61 74 68 2c  /lib -Wl,-rpath,
0d10: 24 7b 70 6b 67 64 69 72 7d 2f 6c 69 62 22 0a 09  ${pkgdir}/lib"..
0d20: 09 09 09 09 09 65 78 70 6f 72 74 20 4c 44 46 4c  .....export LDFL
0d30: 41 47 53 0a 09 09 09 09 09 09 3b 3b 0a 09 09 09  AGS.......;;....
0d40: 09 09 50 41 54 48 29 0a 09 09 09 09 09 09 50 41  ..PATH).......PA
0d50: 54 48 3d 22 24 7b 50 41 54 48 7d 3a 24 7b 70 6b  TH="${PATH}:${pk
0d60: 67 64 69 72 7d 2f 62 69 6e 22 0a 09 09 09 09 09  gdir}/bin"......
0d70: 09 65 78 70 6f 72 74 20 50 41 54 48 0a 09 09 09  .export PATH....
0d80: 09 09 09 3b 3b 0a 09 09 09 09 09 50 4b 47 5f 43  ...;;......PKG_C
0d90: 4f 4e 46 49 47 5f 50 41 54 48 29 0a 09 09 09 09  ONFIG_PATH).....
0da0: 09 09 69 66 20 5b 20 2d 64 20 22 24 7b 70 6b 67  ..if [ -d "${pkg
0db0: 63 6f 6e 66 69 67 64 69 72 7d 22 20 5d 3b 20 74  configdir}" ]; t
0dc0: 68 65 6e 0a 09 09 09 09 09 09 09 50 4b 47 5f 43  hen........PKG_C
0dd0: 4f 4e 46 49 47 5f 50 41 54 48 3d 22 24 7b 50 4b  ONFIG_PATH="${PK
0de0: 47 5f 43 4f 4e 46 49 47 5f 50 41 54 48 7d 3a 24  G_CONFIG_PATH}:$
0df0: 7b 70 6b 67 63 6f 6e 66 69 67 64 69 72 7d 22 0a  {pkgconfigdir}".
0e00: 09 09 09 09 09 09 09 65 78 70 6f 72 74 20 50 4b  .......export PK
0e10: 47 5f 43 4f 4e 46 49 47 5f 50 41 54 48 0a 09 09  G_CONFIG_PATH...
0e20: 09 09 09 09 66 69 0a 09 09 09 09 09 09 3b 3b 0a  ....fi.......;;.
0e30: 09 09 09 09 65 73 61 63 0a 09 09 09 64 6f 6e 65  ....esac....done
0e40: 0a 0a 09 09 09 62 72 65 61 6b 0a 09 09 64 6f 6e  .....break...don
0e50: 65 0a 0a 09 09 69 66 20 5b 20 22 24 7b 70 6b 67  e....if [ "${pkg
0e60: 66 6f 75 6e 64 7d 22 20 3d 20 27 30 27 20 5d 3b  found}" = '0' ];
0e70: 20 74 68 65 6e 0a 09 09 09 64 69 65 20 22 50 61   then....die "Pa
0e80: 63 6b 61 67 65 20 24 7b 70 6b 67 7d 2f 24 7b 70  ckage ${pkg}/${p
0e90: 6b 67 76 65 72 73 69 6f 6e 3a 2d 2a 7d 40 24 7b  kgversion:-*}@${
0ea0: 70 6b 67 64 6f 6d 61 69 6e 7d 20 6e 6f 74 20 66  pkgdomain} not f
0eb0: 6f 75 6e 64 2e 22 0a 09 09 66 69 0a 09 64 6f 6e  ound."...fi..don
0ec0: 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 76 65  e.}..function ve
0ed0: 72 69 66 79 50 72 65 72 65 71 75 69 73 69 74 65  rifyPrerequisite
0ee0: 73 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63  s() {..:.}..func
0ef0: 74 69 6f 6e 20 64 65 74 65 72 6d 69 6e 65 4f 73  tion determineOs
0f00: 41 72 63 68 28 29 20 7b 0a 09 6f 73 3d 22 24 28  Arch() {..os="$(
0f10: 75 6e 61 6d 65 20 2d 73 20 7c 20 64 64 20 63 6f  uname -s | dd co
0f20: 6e 76 3d 6c 63 61 73 65 20 32 3e 2f 64 65 76 2f  nv=lcase 2>/dev/
0f30: 6e 75 6c 6c 29 22 0a 09 61 72 63 68 3d 22 24 28  null)"..arch="$(
0f40: 75 6e 61 6d 65 20 2d 6d 20 7c 20 64 64 20 63 6f  uname -m | dd co
0f50: 6e 76 3d 6c 63 61 73 65 20 32 3e 2f 64 65 76 2f  nv=lcase 2>/dev/
0f60: 6e 75 6c 6c 29 22 0a 0a 09 63 61 73 65 20 22 24  null)"...case "$
0f70: 7b 61 72 63 68 7d 22 20 69 6e 0a 09 09 69 3f 38  {arch}" in...i?8
0f80: 36 29 0a 09 09 09 61 72 63 68 3d 27 69 78 38 36  6)....arch='ix86
0f90: 27 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 7d 0a  '....;;..esac.}.
0fa0: 0a 66 75 6e 63 74 69 6f 6e 20 64 65 74 65 72 6d  .function determ
0fb0: 69 6e 65 50 72 65 66 69 78 28 29 20 7b 0a 09 64  inePrefix() {..d
0fc0: 65 74 65 72 6d 69 6e 65 4f 73 41 72 63 68 0a 0a  etermineOsArch..
0fd0: 09 70 72 65 66 69 78 73 75 66 66 69 78 3d 22 24  .prefixsuffix="$
0fe0: 7b 70 6b 67 7d 2f 24 7b 6f 73 7d 2d 24 7b 61 72  {pkg}/${os}-${ar
0ff0: 63 68 7d 2f 24 7b 76 65 72 73 69 6f 6e 7d 22 0a  ch}/${version}".
1000: 09 70 72 65 66 69 78 3d 22 2f 6f 70 74 2f 61 70  .prefix="/opt/ap
1010: 70 66 73 2f 24 7b 64 6f 6d 61 69 6e 7d 2f 24 7b  pfs/${domain}/${
1020: 70 72 65 66 69 78 73 75 66 66 69 78 7d 22 0a 09  prefixsuffix}"..
1030: 64 65 73 74 64 69 72 3d 22 24 28 70 77 64 29 2f  destdir="$(pwd)/
1040: 49 4e 53 54 22 0a 0a 09 6d 6b 64 69 72 20 22 24  INST"...mkdir "$
1050: 7b 64 65 73 74 64 69 72 7d 22 20 7c 7c 20 64 69  {destdir}" || di
1060: 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 72  e.}..function pr
1070: 65 63 6f 6e 66 69 67 75 72 65 28 29 20 7b 0a 09  econfigure() {..
1080: 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 6f  :.}..function po
1090: 73 74 63 6f 6e 66 69 67 75 72 65 28 29 20 7b 0a  stconfigure() {.
10a0: 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 63  .:.}..function c
10b0: 6f 6e 66 69 67 75 72 65 5f 67 63 63 28 29 20 7b  onfigure_gcc() {
10c0: 0a 09 6c 6f 63 61 6c 20 67 6c 69 62 63 64 69 72  ..local glibcdir
10d0: 20 6c 69 6e 75 78 68 65 61 64 65 72 73 64 69 72   linuxheadersdir
10e0: 0a 09 6c 6f 63 61 6c 20 64 79 6e 6c 69 6e 6b 65  ..local dynlinke
10f0: 72 0a 09 6c 6f 63 61 6c 20 67 63 63 5f 64 65 66  r..local gcc_def
1100: 61 75 6c 74 5f 68 65 61 64 65 72 73 0a 09 6c 6f  ault_headers..lo
1110: 63 61 6c 20 70 6b 67 20 75 73 65 5f 6e 61 74 69  cal pkg use_nati
1120: 76 65 5f 70 6c 61 74 66 6f 72 6d 0a 0a 09 67 6c  ve_platform...gl
1130: 69 62 63 64 69 72 3d 22 2f 6f 70 74 2f 61 70 70  ibcdir="/opt/app
1140: 66 73 2f 63 6f 72 65 2e 61 70 70 66 73 2e 72 6b  fs/core.appfs.rk
1150: 65 65 6e 65 2e 6f 72 67 2f 67 6c 69 62 63 2f 70  eene.org/glibc/p
1160: 6c 61 74 66 6f 72 6d 2f 6c 61 74 65 73 74 22 0a  latform/latest".
1170: 09 67 6c 69 62 63 64 69 72 3d 22 24 28 72 65 61  .glibcdir="$(rea
1180: 64 6c 69 6e 6b 20 2d 66 20 22 24 7b 67 6c 69 62  dlink -f "${glib
1190: 63 64 69 72 7d 22 29 22 0a 0a 09 6c 69 6e 75 78  cdir}")"...linux
11a0: 68 65 61 64 65 72 73 64 69 72 3d 22 2f 6f 70 74  headersdir="/opt
11b0: 2f 61 70 70 66 73 2f 63 6f 72 65 2e 61 70 70 66  /appfs/core.appf
11c0: 73 2e 72 6b 65 65 6e 65 2e 6f 72 67 2f 6c 69 6e  s.rkeene.org/lin
11d0: 75 78 2d 68 65 61 64 65 72 73 2f 70 6c 61 74 66  ux-headers/platf
11e0: 6f 72 6d 2f 6c 61 74 65 73 74 22 0a 09 6c 69 6e  orm/latest"..lin
11f0: 75 78 68 65 61 64 65 72 73 64 69 72 3d 22 24 28  uxheadersdir="$(
1200: 72 65 61 64 6c 69 6e 6b 20 2d 66 20 22 24 7b 6c  readlink -f "${l
1210: 69 6e 75 78 68 65 61 64 65 72 73 64 69 72 7d 22  inuxheadersdir}"
1220: 29 22 0a 0a 09 64 79 6e 6c 69 6e 6b 65 72 3d 22  )"...dynlinker="
1230: 24 28 6c 73 20 22 24 7b 67 6c 69 62 63 64 69 72  $(ls "${glibcdir
1240: 7d 22 2f 6c 69 62 2f 6c 64 2d 6c 69 6e 75 78 2a  }"/lib/ld-linux*
1250: 2e 73 6f 2e 2a 20 7c 20 74 61 69 6c 20 2d 6e 20  .so.* | tail -n 
1260: 31 29 22 0a 0a 09 69 66 20 5b 20 21 20 2d 66 20  1)"...if [ ! -f 
1270: 22 24 7b 64 79 6e 6c 69 6e 6b 65 72 7d 22 20 5d  "${dynlinker}" ]
1280: 3b 20 74 68 65 6e 0a 09 09 64 69 65 20 27 67 6c  ; then...die 'gl
1290: 69 62 63 20 64 69 72 65 63 74 6f 72 79 20 69 73  ibc directory is
12a0: 20 6e 6f 74 20 61 76 61 69 6c 61 62 6c 65 20 28   not available (
12b0: 61 70 70 66 73 20 72 75 6e 6e 69 6e 67 2f 77 6f  appfs running/wo
12c0: 72 6b 69 6e 67 3f 29 27 0a 09 66 69 0a 0a 09 75  rking?)'..fi...u
12d0: 73 65 5f 6e 61 74 69 76 65 5f 70 6c 61 74 66 6f  se_native_platfo
12e0: 72 6d 3d 27 30 27 0a 09 66 6f 72 20 70 6b 67 20  rm='0'..for pkg 
12f0: 69 6e 20 22 24 7b 72 65 71 75 69 72 65 5b 40 5d  in "${require[@]
1300: 7d 22 3b 20 64 6f 0a 09 09 63 61 73 65 20 22 24  }"; do...case "$
1310: 7b 70 6b 67 7d 22 20 69 6e 0a 09 09 09 40 6e 61  {pkg}" in....@na
1320: 74 69 76 65 2d 6f 73 29 0a 09 09 09 09 75 73 65  tive-os).....use
1330: 5f 6e 61 74 69 76 65 5f 70 6c 61 74 66 6f 72 6d  _native_platform
1340: 3d 27 31 27 0a 09 09 09 09 3b 3b 0a 09 09 65 73  ='1'.....;;...es
1350: 61 63 0a 09 64 6f 6e 65 0a 0a 09 69 66 20 5b 20  ac..done...if [ 
1360: 22 24 7b 75 73 65 5f 6e 61 74 69 76 65 5f 70 6c  "${use_native_pl
1370: 61 74 66 6f 72 6d 7d 22 20 3d 20 27 30 27 20 5d  atform}" = '0' ]
1380: 3b 20 74 68 65 6e 0a 09 09 67 63 63 5f 64 65 66  ; then...gcc_def
1390: 61 75 6c 74 5f 68 65 61 64 65 72 73 3d 22 24 28  ault_headers="$(
13a0: 65 63 68 6f 20 27 27 20 7c 20 24 7b 43 50 50 3a  echo '' | ${CPP:
13b0: 2d 63 70 70 7d 20 2d 76 20 32 3e 26 31 20 7c 20  -cpp} -v 2>&1 | 
13c0: 73 65 64 20 27 2f 5e 45 6e 64 20 6f 66 20 73 65  sed '/^End of se
13d0: 61 72 63 68 20 6c 69 73 74 2f 2c 24 20 64 3b 30  arch list/,$ d;0
13e0: 2c 2f 73 65 61 72 63 68 20 73 74 61 72 74 73 20  ,/search starts 
13f0: 68 65 72 65 3a 24 2f 20 64 27 20 7c 20 67 72 65  here:$/ d' | gre
1400: 70 20 27 2f 67 63 63 2f 27 20 7c 20 73 65 64 20  p '/gcc/' | sed 
1410: 27 73 40 5e 20 2a 40 2d 69 73 79 73 74 65 6d 20  's@^ *@-isystem 
1420: 40 27 20 7c 20 74 72 20 24 27 5c 6e 27 20 27 20  @' | tr $'\n' ' 
1430: 27 29 22 0a 0a 09 09 43 43 3d 22 24 7b 43 43 3a  ')"....CC="${CC:
1440: 2d 67 63 63 7d 20 2d 6e 6f 73 74 64 69 6e 63 20  -gcc} -nostdinc 
1450: 24 7b 67 63 63 5f 64 65 66 61 75 6c 74 5f 68 65  ${gcc_default_he
1460: 61 64 65 72 73 7d 20 2d 69 73 79 73 74 65 6d 20  aders} -isystem 
1470: 24 7b 67 6c 69 62 63 64 69 72 7d 2f 69 6e 63 6c  ${glibcdir}/incl
1480: 75 64 65 22 0a 09 09 43 58 58 3d 22 24 7b 43 58  ude"...CXX="${CX
1490: 58 3a 2d 67 2b 2b 7d 20 2d 6e 6f 73 74 64 69 6e  X:-g++} -nostdin
14a0: 63 20 24 7b 67 63 63 5f 64 65 66 61 75 6c 74 5f  c ${gcc_default_
14b0: 68 65 61 64 65 72 73 7d 20 2d 69 73 79 73 74 65  headers} -isyste
14c0: 6d 20 24 7b 67 6c 69 62 63 64 69 72 7d 2f 69 6e  m ${glibcdir}/in
14d0: 63 6c 75 64 65 22 0a 0a 09 09 69 66 20 21 20 65  clude"....if ! e
14e0: 63 68 6f 20 22 20 24 7b 72 65 71 75 69 72 65 5b  cho " ${require[
14f0: 2a 5d 7d 20 22 20 7c 20 67 72 65 70 20 27 20 6c  *]} " | grep ' l
1500: 69 6e 75 78 2d 68 65 61 64 65 72 73 5b 2f 40 3a  inux-headers[/@:
1510: 20 5d 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20   ]' >/dev/null; 
1520: 74 68 65 6e 0a 09 09 09 43 43 3d 22 24 7b 43 43  then....CC="${CC
1530: 7d 20 2d 69 73 79 73 74 65 6d 20 24 7b 6c 69 6e  } -isystem ${lin
1540: 75 78 68 65 61 64 65 72 73 64 69 72 7d 2f 69 6e  uxheadersdir}/in
1550: 63 6c 75 64 65 22 0a 09 09 09 43 58 58 3d 22 24  clude"....CXX="$
1560: 7b 43 58 58 7d 20 2d 69 73 79 73 74 65 6d 20 24  {CXX} -isystem $
1570: 7b 6c 69 6e 75 78 68 65 61 64 65 72 73 64 69 72  {linuxheadersdir
1580: 7d 2f 69 6e 63 6c 75 64 65 22 0a 09 09 66 69 0a  }/include"...fi.
1590: 09 65 6c 73 65 0a 09 09 43 43 3d 22 24 7b 43 43  .else...CC="${CC
15a0: 3a 2d 67 63 63 7d 20 2d 69 73 79 73 74 65 6d 20  :-gcc} -isystem 
15b0: 24 7b 67 6c 69 62 63 64 69 72 7d 2f 69 6e 63 6c  ${glibcdir}/incl
15c0: 75 64 65 22 0a 09 09 43 58 58 3d 22 24 7b 43 58  ude"...CXX="${CX
15d0: 58 3a 2d 67 2b 2b 7d 20 2d 69 73 79 73 74 65 6d  X:-g++} -isystem
15e0: 20 24 7b 67 6c 69 62 63 64 69 72 7d 2f 69 6e 63   ${glibcdir}/inc
15f0: 6c 75 64 65 22 0a 09 66 69 0a 0a 09 42 55 49 4c  lude"..fi...BUIL
1600: 44 5f 43 43 3d 22 24 7b 43 43 7d 22 0a 09 48 4f  D_CC="${CC}"..HO
1610: 53 54 5f 43 43 3d 22 24 7b 43 43 7d 22 0a 0a 09  ST_CC="${CC}"...
1620: 4c 44 46 4c 41 47 53 3d 22 24 7b 4c 44 46 4c 41  LDFLAGS="${LDFLA
1630: 47 53 7d 20 2d 4c 24 7b 67 6c 69 62 63 64 69 72  GS} -L${glibcdir
1640: 7d 2f 6c 69 62 20 2d 57 6c 2c 2d 72 70 61 74 68  }/lib -Wl,-rpath
1650: 2c 24 7b 67 6c 69 62 63 64 69 72 7d 2f 6c 69 62  ,${glibcdir}/lib
1660: 20 2d 57 6c 2c 2d 2d 64 79 6e 61 6d 69 63 2d 6c   -Wl,--dynamic-l
1670: 69 6e 6b 65 72 2c 24 7b 64 79 6e 6c 69 6e 6b 65  inker,${dynlinke
1680: 72 7d 22 0a 09 69 66 20 5b 20 2d 7a 20 22 24 7b  r}"..if [ -z "${
1690: 61 70 70 66 73 5f 62 75 69 6c 64 5f 6e 6f 5f 64  appfs_build_no_d
16a0: 65 66 61 75 6c 74 5f 73 79 6d 76 65 72 7d 22 20  efault_symver}" 
16b0: 5d 3b 20 74 68 65 6e 0a 09 09 4c 44 46 4c 41 47  ]; then...LDFLAG
16c0: 53 3d 22 24 7b 4c 44 46 4c 41 47 53 7d 20 2d 57  S="${LDFLAGS} -W
16d0: 6c 2c 2d 2d 64 65 66 61 75 6c 74 2d 73 79 6d 76  l,--default-symv
16e0: 65 72 22 0a 09 66 69 0a 0a 09 50 4b 47 5f 43 4f  er"..fi...PKG_CO
16f0: 4e 46 49 47 5f 4c 49 42 44 49 52 3d 22 24 7b 67  NFIG_LIBDIR="${g
1700: 6c 69 62 63 64 69 72 7d 2f 6c 69 62 2f 70 6b 67  libcdir}/lib/pkg
1710: 63 6f 6e 66 69 67 22 0a 0a 09 65 78 70 6f 72 74  config"...export
1720: 20 43 43 20 42 55 49 4c 44 5f 43 43 20 48 4f 53   CC BUILD_CC HOS
1730: 54 5f 43 43 20 4c 44 46 4c 41 47 53 20 50 4b 47  T_CC LDFLAGS PKG
1740: 5f 43 4f 4e 46 49 47 5f 4c 49 42 44 49 52 0a 7d  _CONFIG_LIBDIR.}
1750: 0a 0a 66 75 6e 63 74 69 6f 6e 20 63 6f 6e 66 69  ..function confi
1760: 67 75 72 65 28 29 20 7b 0a 09 63 6f 6e 66 69 67  gure() {..config
1770: 75 72 65 5f 67 63 63 0a 09 2e 2f 63 6f 6e 66 69  ure_gcc.../confi
1780: 67 75 72 65 20 2d 2d 70 72 65 66 69 78 3d 22 24  gure --prefix="$
1790: 7b 70 72 65 66 69 78 7d 22 20 2d 2d 73 79 73 63  {prefix}" --sysc
17a0: 6f 6e 66 64 69 72 3d 22 24 7b 70 72 65 66 69 78  onfdir="${prefix
17b0: 7d 2f 65 74 63 22 20 2d 2d 6c 69 62 64 69 72 3d  }/etc" --libdir=
17c0: 22 24 7b 70 72 65 66 69 78 7d 2f 6c 69 62 22 20  "${prefix}/lib" 
17d0: 2d 2d 6c 6f 63 61 6c 73 74 61 74 65 64 69 72 3d  --localstatedir=
17e0: 2f 76 61 72 20 22 24 7b 63 6f 6e 66 69 67 75 72  /var "${configur
17f0: 65 5f 65 78 74 72 61 5b 40 5d 7d 22 0a 7d 0a 0a  e_extra[@]}".}..
1800: 66 75 6e 63 74 69 6f 6e 20 70 72 65 62 75 69 6c  function prebuil
1810: 64 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63  d() {..:.}..func
1820: 74 69 6f 6e 20 70 6f 73 74 62 75 69 6c 64 28 29  tion postbuild()
1830: 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f   {..:.}..functio
1840: 6e 20 62 75 69 6c 64 28 29 20 7b 0a 09 67 72 65  n build() {..gre
1850: 70 20 22 44 45 53 54 44 49 52 22 20 4d 61 6b 65  p "DESTDIR" Make
1860: 66 69 6c 65 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20  file >/dev/null 
1870: 7c 7c 20 64 69 65 20 22 44 6f 6e 27 74 20 6b 6e  || die "Don't kn
1880: 6f 77 20 68 6f 77 20 74 6f 20 62 75 69 6c 64 20  ow how to build 
1890: 74 68 69 73 20 73 6f 66 74 77 61 72 65 22 0a 0a  this software"..
18a0: 09 6d 61 6b 65 20 22 24 7b 6d 61 6b 65 5f 65 78  .make "${make_ex
18b0: 74 72 61 5b 40 5d 7d 22 0a 7d 0a 0a 66 75 6e 63  tra[@]}".}..func
18c0: 74 69 6f 6e 20 70 72 65 69 6e 73 74 61 6c 6c 28  tion preinstall(
18d0: 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69  ) {..:.}..functi
18e0: 6f 6e 20 70 6f 73 74 69 6e 73 74 61 6c 6c 28 29  on postinstall()
18f0: 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f   {..:.}..functio
1900: 6e 20 69 6e 73 74 61 6c 6c 28 29 20 7b 0a 09 6d  n install() {..m
1910: 61 6b 65 20 69 6e 73 74 61 6c 6c 20 44 45 53 54  ake install DEST
1920: 44 49 52 3d 22 24 7b 64 65 73 74 64 69 72 7d 22  DIR="${destdir}"
1930: 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 63 6c 65  .}..function cle
1940: 61 6e 75 70 28 29 20 7b 0a 09 63 64 20 22 24 7b  anup() {..cd "${
1950: 77 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65 78 69  workdir}" || exi
1960: 74 20 31 0a 09 63 64 20 2e 2e 20 7c 7c 20 65 78  t 1..cd .. || ex
1970: 69 74 20 31 0a 09 72 6d 20 2d 72 66 20 22 24 7b  it 1..rm -rf "${
1980: 77 6f 72 6b 64 69 72 7d 22 0a 7d 0a 0a 66 75 6e  workdir}".}..fun
1990: 63 74 69 6f 6e 20 64 69 65 28 29 20 7b 0a 09 6c  ction die() {..l
19a0: 6f 63 61 6c 20 6d 65 73 73 61 67 65 0a 0a 09 6d  ocal message...m
19b0: 65 73 73 61 67 65 3d 22 24 31 22 0a 0a 09 69 66  essage="$1"...if
19c0: 20 5b 20 2d 6e 20 22 24 7b 6d 65 73 73 61 67 65   [ -n "${message
19d0: 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 65 63 68  }" ]; then...ech
19e0: 6f 20 22 65 72 72 6f 72 3a 20 24 7b 6d 65 73 73  o "error: ${mess
19f0: 61 67 65 7d 22 20 3e 26 32 0a 09 66 69 0a 0a 09  age}" >&2..fi...
1a00: 65 78 69 74 20 31 0a 7d 0a 0a 73 63 72 69 70 74  exit 1.}..script
1a10: 64 69 72 3d 22 24 28 63 64 20 22 24 28 64 69 72  dir="$(cd "$(dir
1a20: 6e 61 6d 65 20 22 24 28 77 68 69 63 68 20 22 24  name "$(which "$
1a30: 30 22 29 22 29 22 20 26 26 20 70 77 64 29 22 0a  0")")" && pwd)".
1a40: 69 66 20 5b 20 2d 7a 20 22 24 7b 73 63 72 69 70  if [ -z "${scrip
1a50: 74 64 69 72 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  tdir}" ]; then..
1a60: 65 63 68 6f 20 22 55 6e 61 62 6c 65 20 74 6f 20  echo "Unable to 
1a70: 6c 6f 63 61 74 65 20 73 63 72 69 70 74 20 64 69  locate script di
1a80: 72 65 63 74 6f 72 79 22 20 3e 26 32 0a 0a 09 65  rectory" >&2...e
1a90: 78 69 74 20 31 0a 66 69 0a 0a 63 64 20 22 24 7b  xit 1.fi..cd "${
1aa0: 73 63 72 69 70 74 64 69 72 7d 22 20 7c 7c 20 65  scriptdir}" || e
1ab0: 78 69 74 20 31 0a 0a 69 66 20 5b 20 2d 66 20 27  xit 1..if [ -f '
1ac0: 62 75 69 6c 64 2e 63 6f 6e 66 27 20 5d 3b 20 74  build.conf' ]; t
1ad0: 68 65 6e 0a 09 2e 20 27 62 75 69 6c 64 2e 63 6f  hen... 'build.co
1ae0: 6e 66 27 0a 66 69 0a 0a 69 66 20 5b 20 2d 64 20  nf'.fi..if [ -d 
1af0: 22 70 6b 67 73 2f 24 7b 70 6b 67 7d 22 20 5d 3b  "pkgs/${pkg}" ];
1b00: 20 74 68 65 6e 0a 09 70 6b 67 64 69 72 3d 22 24   then..pkgdir="$
1b10: 28 70 77 64 29 2f 70 6b 67 73 2f 24 7b 70 6b 67  (pwd)/pkgs/${pkg
1b20: 7d 22 0a 09 70 6b 67 66 69 6c 65 3d 22 24 7b 70  }"..pkgfile="${p
1b30: 6b 67 64 69 72 7d 2f 69 6e 66 6f 22 0a 65 6c 73  kgdir}/info".els
1b40: 65 0a 09 70 6b 67 66 69 6c 65 3d 22 24 28 70 77  e..pkgfile="$(pw
1b50: 64 29 2f 70 6b 67 73 2f 24 7b 70 6b 67 7d 22 0a  d)/pkgs/${pkg}".
1b60: 09 70 6b 67 64 69 72 3d 22 24 7b 70 6b 67 66 69  .pkgdir="${pkgfi
1b70: 6c 65 7d 22 0a 66 69 0a 0a 69 66 20 5b 20 21 20  le}".fi..if [ ! 
1b80: 2d 65 20 22 24 7b 70 6b 67 66 69 6c 65 7d 22 20  -e "${pkgfile}" 
1b90: 5d 3b 20 74 68 65 6e 0a 09 65 63 68 6f 20 22 49  ]; then..echo "I
1ba0: 6e 76 61 6c 69 64 20 70 61 63 6b 61 67 65 2e 22  nvalid package."
1bb0: 20 3e 26 32 0a 0a 09 65 78 69 74 20 31 0a 66 69   >&2...exit 1.fi
1bc0: 0a 0a 70 6b 67 64 61 74 65 3d 22 24 28 66 6f 72  ..pkgdate="$(for
1bd0: 20 61 72 74 69 66 61 63 74 20 69 6e 20 24 28 66   artifact in $(f
1be0: 69 6e 64 20 22 24 7b 70 6b 67 64 69 72 7d 22 20  ind "${pkgdir}" 
1bf0: 2d 74 79 70 65 20 66 20 2d 70 72 69 6e 74 30 20  -type f -print0 
1c00: 7c 20 78 61 72 67 73 20 2d 6e 20 31 20 2d 30 20  | xargs -n 1 -0 
1c10: 66 6f 73 73 69 6c 20 66 69 6e 66 6f 20 2d 2d 6c  fossil finfo --l
1c20: 69 6d 69 74 20 31 20 2d 2d 77 69 64 74 68 20 30  imit 1 --width 0
1c30: 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 20 7c 20 67   2>/dev/null | g
1c40: 72 65 70 20 27 5e 5b 30 2d 39 5d 5b 30 2d 39 5d  rep '^[0-9][0-9]
1c50: 5b 30 2d 39 5d 5b 30 2d 39 5d 2d 5b 30 2d 39 5d  [0-9][0-9]-[0-9]
1c60: 5b 30 2d 39 5d 2d 5b 30 2d 39 5d 5b 30 2d 39 5d  [0-9]-[0-9][0-9]
1c70: 20 27 20 7c 20 73 65 64 20 27 73 40 5e 5b 5e 20   ' | sed 's@^[^ 
1c80: 5d 2a 20 5c 5b 40 40 3b 73 40 5c 5d 2e 2a 40 40  ]* \[@@;s@\].*@@
1c90: 27 20 7c 20 73 6f 72 74 20 2d 75 29 3b 20 64 6f  ' | sort -u); do
1ca0: 20 66 6f 73 73 69 6c 20 69 6e 66 6f 20 22 24 7b   fossil info "${
1cb0: 61 72 74 69 66 61 63 74 7d 22 20 7c 20 61 77 6b  artifact}" | awk
1cc0: 20 27 2f 5e 75 75 69 64 3a 2f 7b 20 70 72 69 6e   '/^uuid:/{ prin
1cd0: 74 20 24 33 20 24 34 20 7d 27 20 7c 20 73 65 64  t $3 $4 }' | sed
1ce0: 20 27 73 40 5b 2d 3a 5d 40 40 67 3b 73 40 2e 2e   's@[-:]@@g;s@..
1cf0: 24 40 5c 2e 26 40 27 3b 20 64 6f 6e 65 20 7c 20  $@\.&@'; done | 
1d00: 73 6f 72 74 20 2d 6e 20 7c 20 74 61 69 6c 20 2d  sort -n | tail -
1d10: 6e 20 31 29 22 0a 69 66 20 5b 20 2d 7a 20 22 24  n 1)".if [ -z "$
1d20: 7b 70 6b 67 64 61 74 65 7d 22 20 5d 3b 20 74 68  {pkgdate}" ]; th
1d30: 65 6e 0a 09 70 6b 67 64 61 74 65 3d 22 24 28 66  en..pkgdate="$(f
1d40: 69 6e 64 20 22 24 7b 70 6b 67 64 69 72 7d 22 20  ind "${pkgdir}" 
1d50: 2d 74 79 70 65 20 66 20 2d 70 72 69 6e 74 66 20  -type f -printf 
1d60: 27 25 54 59 25 54 6d 25 54 64 25 54 48 25 54 4d  '%TY%Tm%Td%TH%TM
1d70: 2e 25 54 53 5c 6e 27 20 32 3e 2f 64 65 76 2f 6e  .%TS\n' 2>/dev/n
1d80: 75 6c 6c 20 7c 20 63 75 74 20 2d 66 20 31 2d 32  ull | cut -f 1-2
1d90: 20 2d 64 20 27 2e 27 20 7c 20 73 6f 72 74 20 2d   -d '.' | sort -
1da0: 6e 20 7c 20 74 61 69 6c 20 2d 6e 20 31 29 22 0a  n | tail -n 1)".
1db0: 66 69 0a 0a 2e 20 22 24 7b 70 6b 67 66 69 6c 65  fi... "${pkgfile
1dc0: 7d 22 0a 0a 61 72 63 68 69 76 65 64 69 72 3d 22  }"..archivedir="
1dd0: 24 28 70 77 64 29 2f 41 52 43 48 49 56 45 22 0a  $(pwd)/ARCHIVE".
1de0: 77 6f 72 6b 64 69 72 3d 22 77 6f 72 6b 64 69 72  workdir="workdir
1df0: 2d 24 24 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52 41  -$$${RANDOM}${RA
1e00: 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 22 0a  NDOM}${RANDOM}".
1e10: 70 6b 67 61 72 63 68 69 76 65 3d 22 24 7b 61 72  pkgarchive="${ar
1e20: 63 68 69 76 65 64 69 72 7d 2f 24 7b 70 6b 67 7d  chivedir}/${pkg}
1e30: 2d 24 7b 76 65 72 73 69 6f 6e 7d 2e 61 72 63 68  -${version}.arch
1e40: 69 76 65 22 0a 6d 6b 64 69 72 20 22 24 7b 61 72  ive".mkdir "${ar
1e50: 63 68 69 76 65 64 69 72 7d 22 20 3e 2f 64 65 76  chivedir}" >/dev
1e60: 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c  /null 2>/dev/nul
1e70: 6c 0a 6d 6b 64 69 72 20 22 24 7b 77 6f 72 6b 64  l.mkdir "${workd
1e80: 69 72 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 63  ir}" || exit 1.c
1e90: 64 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c  d "${workdir}" |
1ea0: 7c 20 65 78 69 74 20 31 0a 77 6f 72 6b 64 69 72  | exit 1.workdir
1eb0: 3d 22 24 28 70 77 64 29 22 0a 0a 23 20 44 6f 77  ="$(pwd)"..# Dow
1ec0: 6e 6c 6f 61 64 0a 64 6f 77 6e 6c 6f 61 64 0a 0a  nload.download..
1ed0: 23 20 45 78 74 72 61 63 74 0a 65 78 74 72 61 63  # Extract.extrac
1ee0: 74 0a 0a 23 20 49 66 20 77 65 20 6a 75 73 74 20  t..# If we just 
1ef0: 68 61 76 65 20 6f 6e 65 20 64 69 72 65 63 74 6f  have one directo
1f00: 72 79 2c 20 75 73 65 20 74 68 61 74 20 64 69 72  ry, use that dir
1f10: 65 63 74 6f 72 79 0a 64 69 72 3d 22 24 28 65 63  ectory.dir="$(ec
1f20: 68 6f 20 2a 29 22 0a 69 66 20 5b 20 2d 65 20 22  ho *)".if [ -e "
1f30: 24 7b 64 69 72 7d 22 20 5d 3b 20 74 68 65 6e 0a  ${dir}" ]; then.
1f40: 09 6d 76 20 22 24 7b 64 69 72 7d 22 2f 2a 20 2e  .mv "${dir}"/* .
1f50: 0a 66 69 0a 0a 23 20 56 65 72 69 66 79 20 70 72  .fi..# Verify pr
1f60: 65 2d 72 65 71 75 69 73 69 74 65 73 20 61 72 65  e-requisites are
1f70: 20 6d 65 74 0a 76 65 72 69 66 79 52 65 71 75 69   met.verifyRequi
1f80: 72 65 64 50 61 63 6b 61 67 65 73 20 7c 7c 20 64  redPackages || d
1f90: 69 65 20 27 52 65 71 75 69 72 65 64 20 70 61 63  ie 'Required pac
1fa0: 6b 61 67 65 73 20 6d 69 73 73 69 6e 67 27 0a 76  kages missing'.v
1fb0: 65 72 69 66 79 50 72 65 72 65 71 75 69 73 69 74  erifyPrerequisit
1fc0: 65 73 20 7c 7c 20 64 69 65 20 27 50 72 65 72 65  es || die 'Prere
1fd0: 71 75 69 73 69 74 69 65 73 20 66 61 69 6c 65 64  quisities failed
1fe0: 27 0a 0a 23 20 53 74 61 72 74 20 6c 6f 67 67 69  '..# Start loggi
1ff0: 6e 67 0a 73 65 74 20 2d 78 0a 0a 23 20 44 65 74  ng.set -x..# Det
2000: 65 72 6d 69 6e 65 20 70 72 6f 70 65 72 74 69 65  ermine propertie
2010: 73 0a 64 65 74 65 72 6d 69 6e 65 50 72 65 66 69  s.determinePrefi
2020: 78 0a 0a 23 20 41 70 70 6c 79 20 70 61 74 63 68  x..# Apply patch
2030: 65 73 0a 61 70 70 6c 79 5f 70 61 74 63 68 65 73  es.apply_patches
2040: 0a 0a 23 20 53 74 61 72 74 20 74 68 65 20 62 75  ..# Start the bu
2050: 69 6c 64 0a 70 72 65 63 6f 6e 66 69 67 75 72 65  ild.preconfigure
2060: 20 7c 7c 20 64 69 65 20 27 70 72 65 63 6f 6e 66   || die 'preconf
2070: 69 67 75 72 65 20 66 61 69 6c 65 64 27 0a 63 6f  igure failed'.co
2080: 6e 66 69 67 75 72 65 20 7c 7c 20 64 69 65 20 27  nfigure || die '
2090: 63 6f 6e 66 69 67 75 72 65 20 66 61 69 6c 65 64  configure failed
20a0: 27 0a 70 6f 73 74 63 6f 6e 66 69 67 75 72 65 20  '.postconfigure 
20b0: 7c 7c 20 64 69 65 20 27 70 6f 73 74 63 6f 6e 66  || die 'postconf
20c0: 69 67 75 72 65 20 66 61 69 6c 65 64 27 0a 0a 70  igure failed'..p
20d0: 72 65 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27  rebuild || die '
20e0: 70 72 65 62 75 69 6c 64 20 66 61 69 6c 65 64 27  prebuild failed'
20f0: 0a 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 62  .build || die 'b
2100: 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 70 6f 73  uild failed'.pos
2110: 74 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 70  tbuild || die 'p
2120: 6f 73 74 62 75 69 6c 64 20 66 61 69 6c 65 64 27  ostbuild failed'
2130: 0a 0a 70 72 65 69 6e 73 74 61 6c 6c 20 7c 7c 20  ..preinstall || 
2140: 64 69 65 20 27 70 72 65 69 6e 73 74 61 6c 6c 20  die 'preinstall 
2150: 66 61 69 6c 65 64 27 0a 69 6e 73 74 61 6c 6c 20  failed'.install 
2160: 7c 7c 20 64 69 65 20 27 69 6e 73 74 61 6c 6c 20  || die 'install 
2170: 66 61 69 6c 65 64 27 0a 70 6f 73 74 69 6e 73 74  failed'.postinst
2180: 61 6c 6c 20 7c 7c 20 64 69 65 20 27 70 6f 73 74  all || die 'post
2190: 69 6e 73 74 61 6c 6c 20 66 61 69 6c 65 64 27 0a  install failed'.
21a0: 0a 28 0a 09 63 61 73 65 20 22 24 7b 74 61 72 67  .(..case "${targ
21b0: 65 74 6d 6f 64 65 7d 22 20 69 6e 0a 09 09 69 6e  etmode}" in...in
21c0: 73 74 61 6c 6c 29 0a 09 09 09 61 70 70 64 69 72  stall)....appdir
21d0: 3d 22 24 28 61 70 70 66 73 69 6e 73 74 61 6c 6c  ="$(appfsinstall
21e0: 64 69 72 29 2f 24 7b 70 72 65 66 69 78 73 75 66  dir)/${prefixsuf
21f0: 66 69 78 7d 22 0a 09 09 09 6d 6b 64 69 72 20 2d  fix}"....mkdir -
2200: 70 20 22 24 7b 61 70 70 64 69 72 7d 22 0a 0a 09  p "${appdir}"...
2210: 09 09 63 64 20 22 24 7b 64 65 73 74 64 69 72 7d  ..cd "${destdir}
2220: 2f 24 7b 70 72 65 66 69 78 7d 22 20 7c 7c 20 65  /${prefix}" || e
2230: 78 69 74 20 31 0a 0a 09 09 09 63 70 20 2d 72 70  xit 1.....cp -rp
2240: 20 2a 20 22 24 7b 61 70 70 64 69 72 7d 22 0a 09   * "${appdir}"..
2250: 09 09 66 69 6e 64 20 22 24 7b 61 70 70 64 69 72  ..find "${appdir
2260: 7d 22 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72  }" -print0 | xar
2270: 67 73 20 2d 30 20 74 6f 75 63 68 20 2d 74 20 22  gs -0 touch -t "
2280: 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 66  ${pkgdate}"....f
2290: 69 6e 64 20 22 24 7b 61 70 70 64 69 72 7d 22 20  ind "${appdir}" 
22a0: 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20  -print0 | xargs 
22b0: 2d 30 20 74 6f 75 63 68 20 2d 6d 20 2d 74 20 22  -0 touch -m -t "
22c0: 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 66  ${pkgdate}"....f
22d0: 69 6e 64 20 22 24 7b 61 70 70 64 69 72 7d 22 20  ind "${appdir}" 
22e0: 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20  -print0 | xargs 
22f0: 2d 30 20 74 6f 75 63 68 20 2d 61 20 2d 74 20 22  -0 touch -a -t "
2300: 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 3b  ${pkgdate}"....;
2310: 3b 0a 09 09 61 72 63 68 69 76 65 29 0a 09 09 09  ;...archive)....
2320: 61 72 63 68 69 76 65 66 69 6c 65 3d 22 24 7b 73  archivefile="${s
2330: 63 72 69 70 74 64 69 72 7d 2f 24 7b 70 6b 67 7d  criptdir}/${pkg}
2340: 2d 24 7b 76 65 72 73 69 6f 6e 7d 2d 24 28 65 63  -${version}-$(ec
2350: 68 6f 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 20  ho "${pkgdate}" 
2360: 7c 20 73 65 64 20 27 73 40 5c 2e 40 40 67 27 29  | sed 's@\.@@g')
2370: 2d 24 7b 6f 73 7d 2d 24 7b 61 72 63 68 7d 2d 24  -${os}-${arch}-$
2380: 7b 64 6f 6d 61 69 6e 7d 2e 63 70 69 6f 22 0a 09  {domain}.cpio"..
2390: 09 09 63 64 20 22 24 7b 64 65 73 74 64 69 72 7d  ..cd "${destdir}
23a0: 2f 24 7b 70 72 65 66 69 78 7d 2f 2e 2e 2f 2e 2e  /${prefix}/../..
23b0: 2f 2e 2e 22 20 7c 7c 20 65 78 69 74 20 31 0a 09  /.." || exit 1..
23c0: 09 09 66 69 6e 64 20 22 24 7b 70 72 65 66 69 78  ..find "${prefix
23d0: 73 75 66 66 69 78 7d 22 20 2d 70 72 69 6e 74 30  suffix}" -print0
23e0: 20 7c 20 78 61 72 67 73 20 2d 30 20 74 6f 75 63   | xargs -0 touc
23f0: 68 20 2d 74 20 22 24 7b 70 6b 67 64 61 74 65 7d  h -t "${pkgdate}
2400: 22 0a 09 09 09 66 69 6e 64 20 22 24 7b 70 72 65  "....find "${pre
2410: 66 69 78 73 75 66 66 69 78 7d 22 20 2d 70 72 69  fixsuffix}" -pri
2420: 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30 20 74  nt0 | xargs -0 t
2430: 6f 75 63 68 20 2d 6d 20 2d 74 20 22 24 7b 70 6b  ouch -m -t "${pk
2440: 67 64 61 74 65 7d 22 0a 09 09 09 66 69 6e 64 20  gdate}"....find 
2450: 22 24 7b 70 72 65 66 69 78 73 75 66 66 69 78 7d  "${prefixsuffix}
2460: 22 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67  " -print0 | xarg
2470: 73 20 2d 30 20 74 6f 75 63 68 20 2d 61 20 2d 74  s -0 touch -a -t
2480: 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09   "${pkgdate}"...
2490: 09 66 69 6e 64 20 22 24 7b 70 72 65 66 69 78 73  .find "${prefixs
24a0: 75 66 66 69 78 7d 22 20 7c 20 73 6f 72 74 20 7c  uffix}" | sort |
24b0: 20 63 70 69 6f 20 2d 2d 6f 77 6e 65 72 20 30 3a   cpio --owner 0:
24c0: 30 20 2d 48 20 6e 65 77 63 20 2d 6f 20 3e 20 22  0 -H newc -o > "
24d0: 24 7b 61 72 63 68 69 76 65 66 69 6c 65 7d 22 0a  ${archivefile}".
24e0: 09 09 09 3b 3b 0a 09 65 73 61 63 0a 29 20 7c 7c  ...;;..esac.) ||
24f0: 20 64 69 65 20 27 66 69 6e 61 6c 20 69 6e 73 74   die 'final inst
2500: 61 6c 6c 61 74 69 6f 6e 20 66 61 69 6c 65 64 27  allation failed'
2510: 0a 0a 63 6c 65 61 6e 75 70 0a 0a 65 78 69 74 20  ..cleanup..exit 
2520: 30 0a                                            0.